import sys
print 'version 1.2'

if len(sys.argv) < 4:
	print 'usage: python %s filename trackName outbedfile' % sys.argv[0]
	sys.exit(1)

filename = sys.argv[1]
trackType= sys.argv[2]
outfilename = sys.argv[3]
readadd = 0

infile = open(filename,'r')
outfile = open(outfilename, 'w')
outfile.write('track name="%s" visibility=4 itemRgb="On"\n' % (trackType))
#infile.readline()

for line in infile:
	if 'chr' not in line and '/' not in line:
		continue
	fields = line.split()
	if readadd == 0:
		readadd = len(fields[1]) - 1
	#(chrom, start) = fields[3].split(':')
	#sense = fields[4]
	if '/' in line:
		chromfields = fields[6].split('/')
		chrom = chromfields[-1]
	else:
		chrom = fields[6][:-3]
	start = fields[7]
	sense = fields[8]
	if sense == 'F':
		sense = '+'
		senseCode = '0,0,255'
	else:
		sense = '-'
		senseCode = '255,0,0'
	stop = int(start) + readadd
	outfile.write('%s %s %d %s 0 %s - - %s\n' % (chrom.replace('rand','_random'), start, stop, fields[2], sense, senseCode))
outfile.close()
