import sys

print 'version 1.0'
if len(sys.argv) < 4:
	print 'usage: python %s sitefile1 sitefile2 outfile' % sys.argv[0]
	sys.exit(1)

sitefilename1 =  sys.argv[1]
sitefilename2 = sys.argv[2]

outfilename = sys.argv[3]
outfile = open(outfilename, 'w')

siteDict = {}

infile = open(sitefilename1)
infile.readline()
for line in infile:
	fields = line.strip().split()
	if fields[0] not  in siteDict:
		siteDict[fields[0]] = []
	start = int(fields[1])
	stop = int(fields[2])
	siteDict[fields[0]].append((start, stop, fields[3], fields[4]))
infile.close()

infile = open(sitefilename2)
infile.readline()

commonSites = 0
for line in infile:
	fields = line.strip().split()
	chrom = fields[0]
	if chrom not in siteDict:
		continue
	start = int(fields[1])
	stop = int(fields[2])
	mid = start + abs(stop - start)/2
	for (rstart, rstop, rtype, rscore) in siteDict[chrom]:
		rmid = rstart + abs(rstop - rstart)/2
		if abs(mid - rmid) < 10:
			commonSites += 1
			outfile.write('common%d\t%s\t%d\t%d\t%s\t%s\t%s\t%d\t%d\t%s\t%s\n' % (commonSites, chrom, rstart, rstop, rtype, rscore, chrom, start, stop, fields[3], fields[4]))
outfile.close()

print commonSites

