try:
	import psyco
	psyco.full()
except:
	pass
import sys

print 'version 1.1'
if len(sys.argv) < 4:
	print 'usage: python %s label regionfile outbedfile [color]\n' % sys.argv[0]
	print '\twhere color is in comma-delimited RGB without space\n'
	sys.exit(1)

factorlabel = sys.argv[1]
regionfile = open(sys.argv[2])
outfile = open(sys.argv[3], 'w')

if len(sys.argv) > 4:
	color = sys.argv[4]
else:
	color = '0,0,0'

outfile.write('track name=%s visibility=4 color=%s\n' % (factorlabel, color))
for line in regionfile:
	fields = line.strip().split()
	outfile.write('%s\t%s\t%s\t%s\n' % (fields[1], fields[2], fields[3], fields[0]))
outfile.close()
